#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class ZiBorrar05 : Indicator
    {
        #region Variables
		private bool firstTime = true;
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose	= true;
            Overlay				= true;
            PriceTypeSupported	= false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if ( firstTime )
			{
            	// Instrumento al que queremos acceder. En este caso es un futuro que se llama VCTICK y con vencimiento el 12-2008
				DateTime _expiry = new DateTime( 2008, 12, 1, 0, 0, 0, 0, DateTimeKind.Local );
				NinjaTrader.Cbi.Instrument _instrument = NinjaTrader.Cbi.Instrument.GetObject( "VCTICK", InstrumentType.Future, Exchange.Default, _expiry, 0, Right.Unknown );
				
				// Timeframe al que se quiere acceder. En este caso barras de 1 Tick
				NinjaTrader.Data.Period _period = new NinjaTrader.Data.Period( PeriodType.Tick, 1 );
				Print("Instrumento: " + _instrument.ToString());
				Print("Período: " + _period.ToString());
				
				// Sesión. Sólo para saber las horas de inicio y fin de sesión. Creo que da igual qué año se ponga.
				DateTime _sessionBegin 	= new DateTime( 2008, 1, 1, 0, 0, 0, 0, DateTimeKind.Local );
				DateTime _sessionEnd	= new DateTime( 2009, 1, 1, 0, 0, 0, 0, DateTimeKind.Local );
				NinjaTrader.Data.Session _session = new NinjaTrader.Data.Session( _sessionBegin, _sessionEnd, false );
				
				// Barras. Hay que proporcionar las fechas de inicio y fin del intervalo al que queremos acceder. En este caso desde el 01-ene-2007 al 01-ene-2009.
				DateTime _from 	= new DateTime( 2008, 1, 1, 0, 0, 0, 0, DateTimeKind.Local );
				DateTime _to 	= new DateTime( 2009, 1, 1, 0, 0, 0, 0, DateTimeKind.Local );
				NinjaTrader.Data.Bars Barras;
				Barras = NinjaTrader.Data.Bars.GetBars( _instrument, _period, _from, _to, _session, false, false );
				Print( Barras.Count.ToString());
				
				if ( Barras.Count > 0 )
				{
					for(int i=0; i<=Barras.Count-1; i++)
					{
					}
				}
				
				firstTime = false;
			}
		}

        #region Properties

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ZiBorrar05[] cacheZiBorrar05 = null;

        private static ZiBorrar05 checkZiBorrar05 = new ZiBorrar05();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZiBorrar05 ZiBorrar05()
        {
            return ZiBorrar05(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZiBorrar05 ZiBorrar05(Data.IDataSeries input)
        {

            if (cacheZiBorrar05 != null)
                for (int idx = 0; idx < cacheZiBorrar05.Length; idx++)
                    if (cacheZiBorrar05[idx].EqualsInput(input))
                        return cacheZiBorrar05[idx];

            ZiBorrar05 indicator = new ZiBorrar05();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.SetUp();

            ZiBorrar05[] tmp = new ZiBorrar05[cacheZiBorrar05 == null ? 1 : cacheZiBorrar05.Length + 1];
            if (cacheZiBorrar05 != null)
                cacheZiBorrar05.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheZiBorrar05 = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZiBorrar05 ZiBorrar05()
        {
            return _indicator.ZiBorrar05(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZiBorrar05 ZiBorrar05(Data.IDataSeries input)
        {
            return _indicator.ZiBorrar05(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZiBorrar05 ZiBorrar05()
        {
            return _indicator.ZiBorrar05(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZiBorrar05 ZiBorrar05(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ZiBorrar05(input);
        }

    }
}
#endregion
